/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

var unlocked = true ;
var save_class ;
var mouseover_pid = 0 ;

 function initialise_epg() {
  var x=set_scroll ;
  document.getElementById("links").style.width = document.getElementById("epg_detail").style.width ;
	document.getElementById("epg_detail").style.visibility = "visible" ;
	window.scrollTo(0,set_scroll) ;
	if(use_ajax)
	{
		if((tmp = new ajaxObject(0, 'dummy'))===false)
		{
			windows.alert("Your browser does not support Ajax. This configuration setting will be ignored for this session.");
			use_ajax = false ;
			SetCookie ("AjaxCapable", "No");
		}
		else
		{
			SetCookie ("AjaxCapable", "Yes");
		}
		delete tmp ;
	}
 }

function click_day(theDay) {
 theForm = document.getElementById("form_day") ;
 theForm.set_day.value = theDay ;
 theForm.submit() ;
}

function click_hour(theHour) { 
	window.scrollTo(0,theHour*hour_height) ;
}

function highlight_entry(thePID) {
 save_class = thePID.className ;
 if(unlocked) { thePID.className = "prog_detail_over" ; }
}

function lowlight_entry(thePID) {
 if(unlocked) { thePID.className = save_class ; }
}

function mouseover_show(thePID,pid) {
 var theDiv,innerHeight,outerHeight ;
 if(unlocked) 
 { 
  mouseover_pid = pid ;
  innerHeight = document.getElementById("inner_"+pid).offsetHeight ;
  outerHeight = thePID.offsetHeight ;
	if( (innerHeight < (outerHeight-5)) && mouseover_compare_inner ) { return ; }
  theDiv = document.getElementById("div_mouseover") ;
	document.getElementById("mouseover_channel").firstChild.nodeValue    = document.getElementById("prog_channel_"+pid).firstChild.nodeValue ;
	document.getElementById("mouseover_title").firstChild.nodeValue    = document.getElementById("prog_title_"+pid).firstChild.nodeValue ;
	document.getElementById("mouseover_subtitle").firstChild.nodeValue    = document.getElementById("prog_subtitle_"+pid).firstChild.nodeValue ;
	document.getElementById("mouseover_quality").firstChild.nodeValue    = document.getElementById("prog_quality_"+pid).firstChild.nodeValue ;
	document.getElementById("mouseover_time").firstChild.nodeValue    = document.getElementById("prog_time_"+pid).firstChild.nodeValue ;
	document.getElementById("mouseover_desc").firstChild.nodeValue    = document.getElementById("prog_desc_"+pid).firstChild.nodeValue ;
	document.getElementById("mouseover_duration").firstChild.nodeValue    = "("+parseInt(document.getElementById("prog_duration_"+pid).firstChild.nodeValue)+")" ;
	if(document.getElementById("mouseover_subtitle").firstChild.nodeValue==".") { document.getElementById("mouseover_subtitle").firstChild.nodeValue = "" ; }
	
	// set the top and bottom
	if( parseInt(thePID.style.top) < (hour_height*18) )
	{
	 theDiv.style.top    = (parseInt(thePID.style.top)+20)+"px" ;
	 theDiv.style.bottom = "auto" ;
	}
	else
	{
	 theDiv.style.top    = "auto" ;
	 theDiv.style.bottom = ( (25*hour_height) - ( parseInt(thePID.style.top)+parseInt(thePID.style.height) ) )+"px" ;
	}
	
	// set the width
	theDiv.style.width = (Math.min((screen_width/3)-20,400))+"px" ;
	
	// set the left
	if(parseInt(thePID.style.left) > (screen_width/3))
	{
	 //theDiv.style.left = (parseInt(thePID.style.left)-(screen_width/3))+"px" ;
	 theDiv.style.left = (parseInt(thePID.style.left)-(parseInt(theDiv.style.width)+20))+"px" ;
	 //theDiv.style.width = ((screen_width/3)-20)+"px" ;
	}
	else
	{
	 theDiv.style.left = (parseInt(thePID.style.left)+parseInt(thePID.style.width)+20)+"px" ;
	 //theDiv.style.width = ((screen_width/3)-20)+"px" ;
	}

	theDiv.className = "mouseover_display" ;
	theDiv.style.visibility = "visible" ;
	//window.alert("visible");
 }
}

function mouseover_timer_show(theTimer,timer) {
 var theDiv,innerHeight,outerHeight ;
 if(unlocked) 
 { 
  mouseover_pid = timer ;
  theDiv = document.getElementById("div_mouseover") ;
	document.getElementById("mouseover_channel").firstChild.nodeValue    = document.getElementById("timer_channel_"+timer).firstChild.nodeValue ;
	document.getElementById("mouseover_title").firstChild.nodeValue    = document.getElementById("timer_title_"+timer).firstChild.nodeValue ;
	document.getElementById("mouseover_subtitle").firstChild.nodeValue    = "" ;
	document.getElementById("mouseover_desc").firstChild.nodeValue    = document.getElementById("timer_type_"+timer).firstChild.nodeValue ;
	document.getElementById("mouseover_time").firstChild.nodeValue    = document.getElementById("timer_time_"+timer).firstChild.nodeValue ;
	document.getElementById("mouseover_duration").firstChild.nodeValue    = "("+parseInt(document.getElementById("timer_duration_"+timer).firstChild.nodeValue)+")" ;
	
	if( parseInt(theTimer.style.top) < (hour_height*18) )
	{
	 theDiv.style.top    = (parseInt(theTimer.style.top)+20)+"px" ;
	 theDiv.style.bottom = "auto" ;
	}
	else
	{
	 theDiv.style.top    = "auto" ;
	 theDiv.style.bottom = ( (25*hour_height) - ( parseInt(theTimer.style.top)+parseInt(theTimer.style.height) ) )+"px" ;
	}
	
	if(parseInt(theTimer.style.left) > (screen_width/3))
	{
	 theDiv.style.left = (parseInt(theTimer.style.left)-(screen_width/3))+"px" ;
	 theDiv.style.width = ((screen_width/3)-20)+"px" ;
	}
	else
	{
	 theDiv.style.left = (parseInt(theTimer.style.left)+parseInt(theTimer.style.width)+20)+"px" ;
	 theDiv.style.width = ((screen_width/3)-20)+"px" ;
	}
	theDiv.className = "mouseover_display_"+document.getElementById("timer_class_"+timer).firstChild.nodeValue ;
	theDiv.style.visibility = "visible" ;
	//window.alert("visible");
 }
 $x="" ;
}

function mouseover_hide(thePID,pid) {
 if(pid==mouseover_pid) 
 {
  theDiv = document.getElementById("div_mouseover") ;
  theDiv.style.visibility = "hidden" ; 
	mouseover_pid = 0 ;
 }
}

function click_entry(thePID,pid,top,right,height) { 
 var theForm, PIDdisplay, displaydesc, epgdesc, chn, alt, hdtv, i ;
 if(unlocked) {
  thePID.className = "prog_detail" ;
	//displaydesc = document.getElementById("prog_desc") ;
	//epgdesc     = document.getElementById("prog_desc_"+pid) ;
	//displaydesc.firstChild.nodeValue = epgdesc.firstChild.nodeValue ;
	document.getElementById("prog_title").firstChild.nodeValue    = document.getElementById("prog_title_"+pid).firstChild.nodeValue ;
	document.getElementById("prog_subtitle").firstChild.nodeValue = document.getElementById("prog_subtitle_"+pid).firstChild.nodeValue ;
	document.getElementById("prog_date").firstChild.nodeValue     = document.getElementById("prog_date_"+pid).firstChild.nodeValue ;
	document.getElementById("prog_time").firstChild.nodeValue     = document.getElementById("prog_time_"+pid).firstChild.nodeValue ;
	document.getElementById("prog_duration").firstChild.nodeValue = document.getElementById("prog_duration_"+pid).firstChild.nodeValue+" minutes" ;
	document.getElementById("prog_channel").firstChild.nodeValue  = chn = document.getElementById("prog_channel_"+pid).firstChild.nodeValue ;
	document.getElementById("prog_desc").firstChild.nodeValue     = document.getElementById("prog_desc_"+pid).firstChild.nodeValue ;
	if(document.getElementById("prog_subtitle").firstChild.nodeValue==".") { document.getElementById("prog_subtitle").firstChild.nodeValue = "" ; }
	theForm=document.getElementById("form_addtimer")
	theForm.set_newname.value     = document.getElementById("prog_title").firstChild.nodeValue+document.getElementById("prog_subtitle").firstChild.nodeValue ; ;
	//theForm.set_newchannel.value  = document.getElementById("prog_channel_"+pid).firstChild.nodeValue ;
	theForm.set_newstart.value    = document.getElementById("prog_datestamp_"+pid).firstChild.nodeValue ;
	theForm.set_newduration.value = document.getElementById("prog_duration_"+pid).firstChild.nodeValue ;
	theForm.set_pid.value         = pid ;
	theForm.set_scroll.value      = top ;

    for (i=0; i<=chn_count ; i++)
    {
	 if (chn == chn_list[i])
	 {
	  alt = alt_list[i] ;
	  hdtv = hd_list[i] ;
	 }
    }
	
	theForm.set_newchannel.length = 1 ;
	theForm.set_newchannel.options[0].value = chn ;
	theForm.set_newchannel.options[0].text = chn ;
	theForm.set_newchannel.options[0].selected = true ;

	if (alt!="")
	{
		i = theForm.set_newchannel.length ;
		theForm.set_newchannel.length++ ;
		theForm.set_newchannel.options[i].value = alt ;
		theForm.set_newchannel.options[i].text = alt ;
	}

	if (hdtv!="")
	{
		i = theForm.set_newchannel.length ;
		theForm.set_newchannel.length++ ;
		theForm.set_newchannel.options[i].value = hdtv ;
		theForm.set_newchannel.options[i].text = hdtv ;
	}

	if (alt=="" && hdtv=="")
	{
		document.getElementById("prog_channel").style.display = "inline" ;
		document.getElementById("prog_channel_alt").style.display = "none" ;
	}
	else
	{
		document.getElementById("prog_channel").style.display = "none" ;
		document.getElementById("prog_channel_alt").style.display = "inline" ;
	}

    PIDdisplay = document.getElementById("div_addtimer") ;
    PIDdisplay.style.visibility = "visible" ;
    PIDdisplay.style.top = top+"px" ;
	unlocked = false ;
 }
 if(use_ajax) // create the timer display element
 {	
    element = document.createElement("div");
    element.setAttribute("id", "timer_create_"+pid);
    //element.setAttribute("class", "timer_add");
    element.setAttribute("onmouseover", "mouseover_timer_show(this,"+pid+");");
    element.setAttribute("onmouseout", "mouseover_hide(this,"+pid+");");
    var css_text="position:absolute; top:"+top+"px; height:"+height+"px; left:"+(right-8)+"px; width:8px;";  
    element.style.cssText=css_text;    
    element.setAttribute("style",css_text);
    element.className = "timer_add"
    eval("element.onmouseover = function() { mouseover_timer_show(this,"+pid+"); }");
    eval("element.onmouseout = function() { mouseover_hide(this,"+pid+"); }");
    //element.onmouseout = "mouseover_hide(this,"+pid+");"
	element.appendChild(document.createTextNode(""));
	
	ajax_timer_node[pid] = element ;
}
}

function click_display_close(pid) {
 document.getElementById("div_addtimer").style.visibility = "hidden" ;
	delete ajax_timer_node[pid] ;
 unlocked = true ;
}

function click_display_action(theForm) {
 document.getElementById("div_addtimer").style.visibility = "hidden" ;
 unlocked = false ;
 //theForm.action = theForm.action+theForm.set_pid.value ;
 if(use_ajax)
 {
 	ajax_request(theForm);
		unlocked = true ;	
 }
 else
 {
 	theForm.submit();
 }
 
}

function ajax_response(pid)
	{
		var serverresponse = ajax_http_response[pid].split("\t");
		if(serverresponse[2] != pid)
		{
			window.alert("Error: Response ID ("+serverresponse[2]+") does not match request ID()"+pid+").");
		}	
     	if(serverresponse[1]=="success")
     	{
    		var epg_detail=document.getElementById("epg_detail");
			epg_detail.appendChild(ajax_timer_node[serverresponse[2]]);
			if(serverresponse[4]!="") 
			{
				window.alert("Timer submission to "+serverresponse[3]+" was successful. "+serverresponse[4]);
			}
		}
		else
		{
			window.alert("Timer submission to "+serverresponse[3]+" failed. "+serverresponse[4]);		
			//ajax_timer_node[serverresponse[2]] = null ;   // discard the unused node	
			delete ajax_timer_node[serverresponse[2]] ;   // discard the unused node
		}
		//discard the request & response
		delete ajax_http_response[pid] ;
		delete ajax_http_request[pid] ;
		//ajax_http_response[pid] = null ;
		//ajax_http_request[pid] = null ;
		unlocked = true ;	
	}

function ajax_request(theForm)
{
	pid=theForm.set_pid.value;
	
	// set up the ajax request
	ajax_http_request[pid] = new ajaxObject(pid, 'epg_ajax.php');
	ajax_http_request[pid].callback = function(){ ajax_response(this.request_id()); }
   
	var duration = parseInt(theForm.set_newduration.value,10);
   var padding = theForm.set_newpadding.value;
   var parms = "set_action=Add";
   parms += "&set_server="+theForm.set_server.value ;
   parms += "&set_newchannel="+theForm.set_newchannel.value ;
   parms += "&set_newname="+theForm.set_newname.value ;
   parms += "&set_newpadding="+padding.replace("+","~") ;
   //parms += "&set_newpadding="+theForm.set_newpadding.value ;
   parms += "&set_newstart="+theForm.set_newstart.value ;
   //parms += "&set_newduration="+theForm.set_newduration.value ;
   parms += "&set_newduration="+duration ;
   parms += "&set_pid="+pid ;
   parms += "&set_scroll="+theForm.set_scroll.value ;
   parms += "&set_day="+theForm.set_day.value ;
   
   if(padding.toUpperCase()!="Y")
   { 
	padding = padding.split(" "); 
	padding[0] = 0 - eval(padding[0]);
	padding[1] = 0 + eval(padding[1]);
	duration = duration + padding[0] + padding[1];
	var top = parseInt(ajax_timer_node[pid].style.top,10);
	var height = parseInt(ajax_timer_node[pid].style.height,10);
	var bot = top + height ;
	if( top-(padding_top=((padding[0]/60)*hour_height)) < prog_min_top ){ padding_top = top - prog_min_top; }
	if( bot+(padding_bot=((padding[1]/60)*hour_height)) > prog_max_bot ){ padding_bot = prog_max_bot - bot; }
	height = padding_top+height+padding_bot;
	top = top - padding_top;
	ajax_timer_node[pid].style.top = top+"px";
	ajax_timer_node[pid].style.height = height+"px";
	x=0;
   }
   
   
	child = document.createElement("span");
    child.setAttribute("id", "timer_channel_"+pid);
    child.style.cssText="display:none";    
	child.appendChild(document.createTextNode(theForm.set_newchannel.value +" ("+theForm.set_server.value+")" ));
	ajax_timer_node[pid].appendChild(child);
	
	child = document.createElement("span");
    child.setAttribute("id", "timer_time_"+pid);
    child.style.cssText="display:none";    
	//child.appendChild(document.createTextNode(document.getElementById("prog_time_"+pid).firstChild.nodeValue));
	child.appendChild(document.createTextNode(theForm.set_newstart.value));
	ajax_timer_node[pid].appendChild(child);
	
	child = document.createElement("span");
    child.setAttribute("id", "timer_title_"+pid);
    child.style.cssText="display:none";    
	child.appendChild(document.createTextNode(theForm.set_newname.value));
	ajax_timer_node[pid].appendChild(child);
	
	child = document.createElement("span");
    child.setAttribute("id", "timer_duration_"+pid);
    child.style.cssText="display:none";    
	child.appendChild(document.createTextNode(""+duration));
	ajax_timer_node[pid].appendChild(child);
	
	child = document.createElement("span");
    child.setAttribute("id", "timer_type_"+pid);
    child.style.cssText="display:none";    
	child.appendChild(document.createTextNode("Onetime"));
	ajax_timer_node[pid].appendChild(child);
	
	child = document.createElement("span");
    child.setAttribute("id", "timer_class_"+pid);
    child.style.cssText="display:none";    
	child.appendChild(document.createTextNode("timer_add"));
	ajax_timer_node[pid].appendChild(child);
	
   
   ajax_http_request[pid].send_request(parms); 
   
   
    //parent=document.getElementById("epg_detail");
	//parent.appendChild(ajax_timer_node[pid]);
	//unlocked = true ;
	x=0;
}

function adjust_time(tstring,adjust)
{
	var x = tstring.split(":");
	y = 60*x[0].parseInt() + x(1).parseInt() + adjust ;
	h = floor(y/60);
	m = y % 60 ;
	if(h<0) { h=h+24;}
	
}

function create_xmlhttprequest()
{
	/* Create a new XMLHttpRequest object to talk to the Web server */
var xmlHttp = false;
try {
  xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
} catch (e) {
  try {
    xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
  } catch (e2) {
    xmlHttp = false;
  }
}

if (!xmlHttp && typeof XMLHttpRequest != 'undefined') {
  xmlHttp = new XMLHttpRequest();
}
return xmlHttp ;
}
